﻿@model signatureViewModel
@{
    ViewData["Title"] = "امضاء الکترونیکی فایل قرارداد";
    Layout = "~/Views/Shared/_Layout.cshtml";
}



@* upload form *@
<div class="container-fluid" id="main_wrapper_upload">
    <div class="row">
        <div class="col-12">
            <form id="form" name="form" action="/Upload" enctype="multipart/form-data" method="post">
                <div class="upload-btn-wrapper">
                    <div class="sc-2xfn8l-0 bxyVaO sc-6w1ep9-0 iTXuYA">
                        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 96 60">
                            <path d="M61,8 L69,16 L69,58 C69,59.1045695 68.1045695,60 67,60 L31,60 C29.8954305,60 29,59.1045695 29,58 L29,52 L28,52 C27.4477153,52 27,51.5522847 27,51 L27,40 C27,39.4477153 27.4477153,39 28,39 L29,39 L29,10 C29,8.8954305 29.8954305,8 31,8 L61,8 Z M60,9 L31,9 C30.4871642,9 30.0644928,9.38604019 30.0067277,9.88337887 L30,10 L30,39 L50,39 C50.5522847,39 51,39.4477153 51,40 L51,51 C51,51.5522847 50.5522847,52 50,52 L30,52 L30,58 C30,58.5128358 30.3860402,58.9355072 30.8833789,58.9932723 L31,59 L67,59 C67.5128358,59 67.9355072,58.6139598 67.9932723,58.1166211 L68,58 L68,17 L60,17 L60,9 Z M59,50 L59,51 L53,51 L53,50 L59,50 Z M32.3146067,42 L30,42 L30,49 L31.3033708,49 L31.3033708,46.4311927 L32.3595506,46.4311927 C33.9438202,46.4311927 35.1573034,45.7140673 35.1573034,44.1620795 C35.1573034,42.5351682 33.9438202,42 32.3146067,42 Z M38.505618,42 L36.5393258,42 L36.5393258,49 L38.5730337,49 C40.752809,49 42.0786517,47.7905199 42.0786517,45.4678899 C42.0786517,43.1559633 40.752809,42 38.505618,42 Z M48,42 L43.5617978,42 L43.5617978,49 L44.8651685,49 L44.8651685,46.0779817 L47.5393258,46.0779817 L47.5393258,45.029052 L44.8651685,45.029052 L44.8651685,43.0489297 L48,43.0489297 L48,42 Z M38.4157303,43.0061162 C39.8988764,43.0061162 40.741573,43.7553517 40.741573,45.4678899 C40.741573,47.1222018 39.9649438,47.9281908 38.5906208,47.990023 L38.4157303,47.9938838 L37.8426966,47.9938838 L37.8426966,43.0061162 L38.4157303,43.0061162 Z M59,45 L59,46 L53,46 L53,45 L59,45 Z M32.2134831,42.9954128 C33.3033708,42.9954128 33.8764045,43.2844037 33.8764045,44.1620795 C33.8764045,44.9679799 33.4086155,45.3851518 32.4449351,45.4314423 L32.258427,45.4357798 L31.3033708,45.4357798 L31.3033708,42.9954128 L32.2134831,42.9954128 Z M59,40 L59,41 L53,41 L53,40 L59,40 Z M59,35 L59,36 L39,36 L39,35 L59,35 Z M59,30 L59,31 L39,31 L39,30 L59,30 Z M61,9.415 L61,16 L67.585,16 L61,9.415 Z">
                            </path>
                        </svg>
                    </div>
                    <div color="rgba(0,85,255,1)" class="l3tlg0-4 bAEODD">
                        <button color="rgba(0,85,255,1)" type="button" class="l3tlg0-0 xTa-DS">
                            <span class="sc-1rkezdt-7 cxlSWI">آپلود فایل <span style="display: inline-block;font-size: 18px;vertical-align: sub;color: black;">PDF</span></span>
                            <div class="sc-2xfn8l-0 bxyVaO sc-2wite4-0 SBukn">
                                <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24">
                                    <path d="M13 12v-2h1v2h2v1h-2v2h-1v-2h-2v-1h2zm5 8H6V4H5v17h13v-1zm1 0v2H4V3h2V1h10l5 5v14h-2zM7 2v17h13V6l-4-4H7zm9 0l4 4h-4V2z"></path>
                                </svg>
                            </div>
                        </button>
                    </div>
                    <input id="file" name="file" type="file" size="1" onchange="uploadFiles('file' , 'pdf');" />                   
                    @Html.AntiForgeryToken()
                </div>
            </form>
        </div>
    </div>
</div>

<div id="wrapper-pdf-viewer">
    <div class="row" id="navigation">
        <div class="col-12">
            <ul class="nav justify-content-center">             
                <li class="nav-item">
                    <a class="nav-link active">
                        <span id="Sign_Modal">ایجاد امضاء</span>
                        <span>
                            <svg style="margin-top: -2px;" width="26" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 24 24" fill="#000">
                                <path d="M16.5854276,4.12589123 C17.2032776,6.6565585 16.0211411,8.61633674 13.1427828,10.0076039 C12.9419815,10.8207127 12.7335909,11.7072897 12.5177015,12.6672062 C12.809646,12.5258231 13.1195321,12.3850852 13.4510201,12.242088 C13.883633,12.0554675 14.1029395,11.9654949 15.1602361,11.5366609 C16.5933916,10.9553805 17.4696871,10.9456232 17.3807605,11.9598769 C17.3434781,12.3851025 17.0732941,12.811056 16.3583443,13.7604438 C16.3293534,13.7989214 16.3293534,13.7989214 16.3004038,13.8372848 C15.9909349,14.2472769 15.9935705,14.2437708 15.8930737,14.3809467 C15.6456325,14.7186982 15.4015054,15.0481182 15.1604139,15.369555 C15.5822784,15.1225921 16.0769765,14.8257076 16.6438666,14.4792113 C18.0009572,13.649726 19.0296004,13.2286869 19.780514,13.2286869 C20.7215864,13.2286869 21.2274665,13.873068 21.2045262,14.9168176 L20.2047677,14.8948442 C20.2163236,14.3690685 20.1061151,14.2286869 19.780514,14.2286869 C19.2647541,14.2286869 18.3761389,14.5924105 17.1653862,15.3324506 C15.8711573,16.1235133 14.9443713,16.6617581 14.3777502,16.9506963 C14.0534874,17.1160483 13.8396397,17.2062607 13.6762278,17.2325141 C13.3734276,17.2811615 13.0407341,17.1652395 13.0261766,16.7308456 C13.0198757,16.5428275 13.0834627,16.4284246 13.198477,16.2866707 C13.8039413,15.513717 14.433261,14.6814692 15.0863917,13.7899609 C15.1816285,13.6599648 15.1878701,13.6513614 15.424149,13.3383039 L15.5595207,13.1588785 C15.8667581,12.7508953 16.0853645,12.4397082 16.2201071,12.2203567 C16.0408294,12.2711867 15.8120113,12.3514276 15.5360919,12.4633391 C14.4871732,12.888775 14.2700508,12.9778516 13.8471167,13.1602968 C13.2374785,13.4232824 12.7098816,13.6753419 12.2369568,13.937406 C12.2177276,14.0258657 12.1984426,14.1148739 12.1791018,14.2044304 C11.8171007,15.6820448 11.4368917,16.9472616 11.0329784,18.0006251 L21,18 L21,19 L10.6134713,18.9996148 C9.86200251,20.6247773 9.02892511,21.5743596 8.08289839,21.8514663 C7.36828081,22.0607896 6.78326657,21.9003695 6.49749504,21.353781 C6.28020588,20.9381771 6.28522704,20.3688522 6.45651227,19.6787416 C6.51032779,19.4619182 6.58070752,19.2344858 6.66552296,19.0004997 L3,19 L3,18 L7.09619983,17.9996255 C7.48392861,17.2151198 7.99000465,16.4210545 8.54399931,15.7516119 C8.70957964,15.551526 8.87560125,15.3619474 9.04283409,15.1819076 C9.76299665,14.4065939 10.4798775,13.819308 11.3544621,13.292307 C11.5747632,12.2893761 11.7878751,11.3583438 11.9939136,10.4989637 C10.9240356,10.9046326 9.676948,11.2504843 8.25619496,11.5366002 L8.05877513,10.5562812 C9.75356482,10.2149789 11.1600735,9.79955793 12.285925,9.31019293 C12.9020528,6.86570707 13.4510918,5.10508188 13.936467,4.0210344 C14.8551106,1.96931557 16.0622115,1.98283755 16.5854276,4.12589123 Z M9.50181926,18.9999035 L7.73822566,19.0005516 C7.60398423,19.3232126 7.49791462,19.6341763 7.42706451,19.9196324 C7.3092581,20.394276 7.30618927,20.7422346 7.38368399,20.8904569 C7.4183646,20.9567897 7.50178814,20.9796658 7.80179326,20.8917894 C8.36971312,20.7254363 8.94292475,20.0936578 9.50181926,18.9999035 Z M11.0144675,14.7287209 C10.5787167,15.0606045 10.1780957,15.429069 9.77551992,15.8624746 C9.62142626,16.028369 9.46796764,16.2036021 9.31440877,16.3891614 C8.91345816,16.8736668 8.53872703,17.4331344 8.22509164,17.9992229 L9.95582936,18.0012017 C10.3191944,17.1115523 10.6739625,16.0203931 11.0144675,14.7287209 Z M6.33333333,12 L7,12.6666667 L5.66666667,14 L7,15.3333333 L6.33333333,16 L5,14.6666667 L3.66666667,16 L3,15.3333333 L4.33333333,14 L3,12.6666667 L3.66666667,12 L5,13.3333333 L6.33333333,12 Z M14.8491576,4.42968563 C14.4465874,5.32879469 13.9878324,6.75453972 13.4746175,8.70447301 C15.3535901,7.57297399 16.0442073,6.12532405 15.6139616,4.36306991 C15.3300782,3.20030511 15.3992577,3.20108006 14.8491576,4.42968563 Z"></path>
                            </svg>
                        </span>
                    </a>
                    <div id="sing-drag-wrapper">
                        <div class="row">
                            <div class="col-12">
                                <div class="SignatureImageContainer">

                                    <p id="holder_Temperory" style="display:none;"></p>
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-12 text-center">
                                <button class="btn btn-success" id="create-sign" onclick="create_Sign(this)">ایجاد امضاء</button>
                            </div>
                        </div>
                    </div>
                </li>
                <li class="nav-item">
                    <a style="font-weight:500;color:black;" class="nav-link" asp-area="" asp-controller="Sing" asp-action="pdf">
                        <span>بارگذاری مجدد فایل</span>
                        <i class="fa fa-cloud-upload"></i>
                    </a>
                </li>
            </ul>
        </div>
    </div>
    <form method="post">
    </form>
    <div id='pdf-viewer'>
        <div class="wrapper_canvas">
            <div class="container" style="padding-bottom:150px;">
                <div class="row">
                    <div class="col-12">

                    </div>
                </div>
            </div>
        </div>
    </div>
    <div id="final_Confirm">
      <div class="container">
          <div class="row">
              <div class="col-12">
                  <button class="btn btn-dark" disabled>ثبت نهایی امضاء</button>
                  <img src="~/Images/Loader/AjaxLoader.gif" id="loader-sign" />
                  <span>
                      لطفا شکیبا باشید ...
                  </span>
              </div>
          </div>
      </div>
    </div>
</div>

<div class="modal fade" id="Modal" tabindex="-1" role="dialog" aria-labelledby="ModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-top" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title" id="ModalCenterTitle">آپلود تصویر امضاء</h4>
            </div>
            <div class="modal-body">
                <form id="form_sign" name="form" action="/UploadSign" enctype="multipart/form-data" method="post">
                    <div color="rgba(230,103,230,1)" class="l3tlg0-4 lfruip">
                        <button style="height: 40px;" color="rgba(230,103,230,1)" type="button" class="l3tlg0-0 jrDGWu">
                            <div class="sc-2xfn8l-0 bxyVaO sc-2wite4-0 SBukn">
                                <svg viewBox="0 0 24 24" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" fill="#000">
                                    <path d="M20,4 L20,20 L4,20 L4,4 L20,4 Z M8.51066828,12.2811966 L5,14.749 L5,19 L19,19 L19,17.671 L15.3044442,14.2965595 L12.3954966,16.2887431 L8.51066828,12.2811966 Z M19,5 L5,5 L5,13.551 L8.62775422,11 L12.5196074,15.0147932 L15.3887033,13.0499019 L19,16.347 L19,5 Z M16,7 C17.1045695,7 18,7.8954305 18,9 C18,10.1045695 17.1045695,11 16,11 C14.8954305,11 14,10.1045695 14,9 C14,7.8954305 14.8954305,7 16,7 Z"></path>
                                </svg>
                            </div>
                            <div class="cdsn4u-3 jwhSLd">انتخاب تصویر </div>
                        </button>
                        <input id="file-sign" name="file-sign" type="file" onclick="this.value=null;" onchange="uploadFiles('file-sign' , 'img');" />
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="Modal_ConfirmCode" tabindex="-1" role="dialog" aria-labelledby="ModalCenterTitle" aria-hidden="true" style="z-index:99999;">
    <div class="modal-dialog modal-dialog-top modal-sm" role="document">
        <div class="modal-content" style="background: #e9ecef;border:none;cursor: move;">
            <div class="modal-body">
                <div id="form_Confirm_Code">
                    <div class="container">
                        <div class="row">
                            <div class="col-12">
                                <input id="confirmCode" style="background:white;" type="text" class="form-control" placeholder="کد را وارد کنید ...">
                            </div>
                            <div class="col-12 text-center">
                                <input type="submit" id="Register_Confirm_Code" style="font-size:12px;" class="btn btn-success m-t-16" value="ثبت کد تائید" />
                                <img src="~/Images/Loader/ajax-loader.gif" />
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="Modal_Error_sendMobileCode" tabindex="-1" role="dialog" aria-labelledby="ModalCenterTitle" aria-hidden="true" style="top:1px;z-index: 99999;">
    <div class="modal-dialog modal-dialog-top modal-sm" role="document">
        <div class="modal-content" style="border:none;">
            <div class="modal-body">              
                    <div class="container">
                        <div class="row">
                            <div class="col-12">
                                <div class="alert alert-danger" role="alert"></div>
                            </div>                           
                        </div>                   
                     </div>
            </div>
        </div>
    </div>
</div>



<div class="modal fade" id="Modal_share" tabindex="-1" role="dialog" aria-labelledby="ModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-top modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header" style="direction: ltr;border:none;">
                @*<h4 class="modal-title" id="ModalCenterTitle">دریافت فایل</h4>*@
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body" style="margin-top:-30px;">
                <div class="container">
                    <nav class="mb-4">
                        <div class="nav nav-tabs" id="nav-tab" role="tablist">
                            <a class="nav-item nav-link active" id="nav-home-tab" data-toggle="tab" href="#nav-home" role="tab" aria-controls="nav-home" aria-selected="true">
                                <i class='fa fa-cloud-download'></i>
                                دانلود فایل
                            </a>
                            <a class="nav-item nav-link" id="nav-profile-tab" data-toggle="tab" href="#nav-profile" role="tab" aria-controls="nav-profile" aria-selected="false">
                                <i class="fa fa-user-plus"></i>
                                ارسال فایل
                            </a>
                        </div>
                    </nav>
                </div>
                <div class="tab-content" id="nav-tabContent">
                    <div class="tab-pane fade show active" id="nav-home" role="tabpanel" aria-labelledby="nav-home-tab">
                        <div class="container text-center">
                            <p>دانلود فایل امضاء شده</p>
                            <i class="fa fa-check-square-o"></i>
                            <img src="~/Images/Loader/AjaxLoader.gif" id="pdf_download_loader" />
                            <img src="~/Images/others/pdf_down.jpg" id="pdf_download" data-toggle="tooltip" data-placement="top" title="Download PDF" />
                            <div id="Fade_Bg"></div>
                        </div>
                    </div>
                    <div class="tab-pane fade" id="nav-profile" role="tabpanel" aria-labelledby="nav-profile-tab">
                        <form data-ajax="true"
                              data-ajax-url="/Sign/SendContractLink"
                              data-ajax-loading="#spinner"
                              data-ajax-complete="completed"
                              data-ajax-update="message"
                              method="post"
                              id="form_share">

                            <p>اطلاعات ارسال‌کننده</p>
                            <div class="container">
                                <div class="row">
                                    <div class="col-6">
                                        <input asp-for="MobilSender" class="form-control" placeholder="موبایل ارسال کننده">
                                        <span asp-validation-for="MobilSender" class="text-danger"></span>
                                        <div class="row" id="mobile_Detail">
                                            <div class="col-6" style="padding-left:0;">
                                                <input type="button" id="send_MobileCode" class="btn btn-success" value="ارسال کد تائید" />
                                            </div>
                                            <div class="col-6" style="padding-right:0;">
                                                <span id="Holder_image">
                                                    <img src="~/Images/Loader/ajax-loader.gif" />
                                                    <span>ارسال مجدد کد : <span>60</span></span>
                                                </span>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-6">
                                        <input asp-for="NationalCode" class="form-control" placeholder="کد ملی ارسال کننده">
                                        <span asp-validation-for="NationalCode" class="text-danger"></span>
                                    </div>
                                </div>
                                <div class="row m-t-28">
                                    <div class="col-6">
                                        <input asp-for="FullNameSender" class="form-control" placeholder=" نام و نام خانوادگی ارسال کننده ">
                                        <span asp-validation-for="FullNameSender" class="text-danger"></span>
                                    </div>
                                    <div class="col-6">
                                        <input asp-for="EmailSender" class="form-control" placeholder="ایمیل ارسال کننده">
                                        <span asp-validation-for="EmailSender" class="text-danger"></span>
                                    </div>
                                </div>
                            </div>
                            <p style="margin-top: 60px;">اطلاعات ‌دریافت‌کننده</p>
                            <div class="container">
                                <div class="row">
                                    <div class="col-6">
                                        <input asp-for="MobilResever" class="form-control" placeholder="موبایل دریافت کننده ">
                                        <span asp-validation-for="MobilResever" class="text-danger"></span>
                                    </div>
                                    <div class="col-6">
                                        <input asp-for="EmailResever" class="form-control" placeholder="ایمیل دریافت کننده">
                                        <span asp-validation-for="EmailResever" class="text-danger"></span>
                                    </div>
                                </div>
                                <div class="row m-t-28">
                                    <div class="col-12">
                                        <input asp-for="FullNameRecever"  class="form-control" placeholder=" نام و نام خانوادگی دریافت کننده">
                                        <span asp-validation-for="FullNameRecever" class="text-danger"></span>
                                    </div>
                                    <div class="col-12">
                                        <div class="form-group form-check" style="margin:20px 0 0 0;">
                                            <input asp-for="ConfirmSendContractLink" class="form-check-input" id="User_Confirm">
                                            <span asp-validation-for="ConfirmSendContractLink" class="text-danger"></span>
                                            <label class="form-check-label" for="User_Confirm">با تائید شما لینک قرارداد امضاء شده برای طرف مقابل ارسال خواهد شد.</label>
                                        </div>
                                    </div>
                                </div>
                                <div class="row m-t-16">
                                    <div class="col-12">
                                        <input type="submit" id="send_Link" style="font-size:13px;" class="btn btn-success" value="ارسال لینک به ایمیل" />
                                        <img id="spinner" src="~/Images/Loader/ajax-loader.gif" />
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>                  
                </div>
            </div>
        </div>
    </div>
</div>



@section Scripts{
    <script src="~/lib/potrace/potrace.js"></script>
    <script src="~/lib/NewFolder/pdf.js"></script>
    <script src="~/lib/jspdf/jspdf.min.js"></script>
    <script src="~/lib/html2canvas/html2canvas.js"></script>
    <script src="~/Publish/Validation.min.js"></script>
    <script src="~/lib/jquery-ui-1.12.1/jquery-ui.min.js"></script>

    <script>
        var img;
        function uploadFiles(inputId, type) {

            var input = document.getElementById(inputId);
            var file = input.files[0];
            var formData = new FormData();
            formData.append("file", file);
            formData.append("type", type == "img" ? "SIGN" : "PDF");

            $.ajax({
                url: "/Sign/Upload",
                headers: { "RequestVerificationToken": $('#form input:hidden[name="__RequestVerificationToken"]').val() },    
                data: formData,
                processData: false,
                contentType: false,
                type: "POST",
                data: formData,
                success: function (res) {
                    console.log(res)
                    if (!res.error) {
                        if (res.Type == 'PDF') preview(res, 'PDF');
                        if (res.Type == 'SIGN') preview(res, 'SIGN');
                    }
                    else alert("خطایی در هنگام پردازش اطلاعات رخ داده است. دقایقی دیگر مجددا اقدام نمائید.")
                }
            });
        }
        function preview(data, Type) {

            $("#final_Confirm").show();

            if (Type == 'PDF') {

                url = `https://localhost:5001/uploads/Sign/${data.id}/PDF/${data.file}`;
                var thePdf = null;
                var scale = 1.8;

                pdfjsLib.getDocument(url).then(function (pdf) {
                    thePdf = pdf;
                    viewer = document.querySelector('#pdf-viewer .wrapper_canvas .container .row .col-12');

                    for (page = 1; page <= pdf._pdfInfo.numPages; page++) {

                        div = document.createElement("div");
                        div.className = 'holder';
                        canvas = document.createElement("canvas");
                        canvas.className = 'pdf-page-canvas';
                        div.appendChild(canvas);
                        viewer.appendChild(div);
                        renderPage(page, canvas);
                    }
                });
                function renderPage(pageNumber, canvas) {
                    thePdf.getPage(pageNumber).then(function (page) {
                        viewport = page.getViewport(scale);
                        canvas.height = viewport.height;
                        canvas.width = $('.holder').width();
                        page.render({ canvasContext: canvas.getContext('2d'), viewport: viewport });
                    });
                }

                $('#main_wrapper_upload').hide();
                $('#pdf-viewer , #navigation').show();
                $('body,html').css('overflow', 'hidden');

                sessionStorage.setItem("UserFile", data.file);

                console.log(sessionStorage)
            } 

            if (Type == 'SIGN') {

                $('#Modal').modal('hide');
                $("#sing-drag-wrapper").show();

                Potrace.loadImageFromUrl('https://localhost:5001//Uploads/Sign/' + data.id +'/Signature/' + data.file);
                Potrace.process(function () {
                    displaySVG(1);
                });

                function displaySVG(size, type) {
                    var svgdiv = document.getElementById('holder_Temperory');
                    svgdiv.innerHTML = Potrace.getSVG(size, type);
                    var Image = document.createElement('img');
                    Image.id = 'Image-sign';
                    Image.src = "data:image/svg+xml;," + Potrace.getSVG(1)
                    $('.SignatureImageContainer').append(Image)
                }
                sessionStorage.setItem("SignFile", data.file);             
            }
        }

        function create_Sign() {

            var scrollTop = $('#pdf-viewer').scrollTop();
            var isDown;
            var offset = [0, 0];

            img = document.getElementById("Image-sign");

            $("#pdf-viewer .wrapper_canvas .signs_attach").remove()
            $("#pdf-viewer .wrapper_canvas").append(

                `
                           <div class='signs_attach'>
                                 <div class='movable_BoX resize'>
                                       <div onclick='Delete(this)' class='remove_wrapper' title='حذف کردن امضاء'>
                                              <div class='closeButton'>
                                                       <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 12 12"><path fill-rule="evenodd" d="M7.414 6l4.243-4.243L10.243.343 6 4.586 1.757.343.343 1.757 4.586 6 .343 10.243l1.414 1.414L6 7.414l4.243 4.243 1.414-1.414L7.414 6z"></path></svg>
                                             </div>
                                       </div>
                                       <div class='corner-3' title='تغییر سایز امضاء'></div>
                                       <div class='image_container'></div>
                                 </div>
                           </div>
                              `
            )

            $("#pdf-viewer .signs_attach .image_container").append(img);

            $('.resize').resizable({
                ghost: true,
                resize: function (event, ui) {
                    //var width = ui.size.width;
                    //var height = ui.size.height;
                    //$('.image_container img').attr('width', width);
                    //$('.image_container img').attr('height', height);
                }
            });
       
            $('#sing-drag-wrapper').hide();
            var movableBox = $('.movable_BoX')[0];
            var boxPosition = $(window).innerWidth() / 2 - 125;
            movableBox.style.left = boxPosition + 'px';
            movableBox.style.top = scrollTop == 0 ? '70px' : scrollTop + 'px';

            movableBox.addEventListener('mousedown', function (e) {


                isDown = true;
                offset = [
                    movableBox.offsetLeft - e.clientX,
                    movableBox.offsetTop - e.clientY
                ];


                //console.log('mousedown', offset)
            }, true);
            movableBox.addEventListener('mouseup', function (e) {


              

                var x = e.pageX;
                var y = e.pageY;


                mousePosition =
                {
                    x: Math.abs(x),
                    y: Math.abs(y),
                    offsetX: e.offsetX,
                    offsetY: e.offsetY,
                };
            
                sessionStorage.setItem("Lastoffset", JSON.stringify(mousePosition));
                sessionStorage.setItem('scrollTop', $('#pdf-viewer').scrollTop());

                isDown = false;
                $("#final_Confirm button").removeAttr('disabled')

            }, true);
            movableBox.addEventListener('mousemove', function (e) {


           
                if (isDown) {

                    mousePosition =
                    {
                        x: e.clientX,
                        y: e.clientY
                    };

                    //var left_offset = $('Canvas').offset().left;
                    //var top_offset  = $('Canvas').offset().top;

                    //document.querySelector(".movable_BoX").style.transform = "translate3d(" + e.clientX  + "px, " + e.clientY + "px, 0px)";
                    movableBox.style.left = (mousePosition.x + offset[0] + 'px');
                    movableBox.style.top = (mousePosition.y + offset[1] + 'px');

                    //$(".movable_BoX").css({
                    //    'transform': `translate3d(${e.clientX}px, ${e.clientY}px, 0)`
                    //});

                }
            }, true);
        }

        $(document).on('click', '#Sign_Modal', function (e) {

            $('#Modal').modal({
                keyboard: false
            })
        });
        $(document).on('click', '#final_Confirm button', function (e) {
        
                $('#sing-drag-wrapper').hide();
                $('#loader-sign , #final_Confirm span').show();

                var offset = JSON.parse(sessionStorage.getItem('Lastoffset') || '[]')
                var scrollTop = sessionStorage.getItem("scrollTop");
                var index = 0;

                if (scrollTop > 1470)
                {
                    var counter = 2;
                    for (var i = 0; i < $(".pdf-page-canvas").length; i++) {
                        if ((counter * 1470) >= scrollTop) {
                            index = counter - 1;
                            break;
                        }
                        counter++;
                    }
                }
               
                var Canvas = $(".pdf-page-canvas")[index];
                $(Canvas).css("width", "auto !important")
                var ctx = Canvas.getContext("2d");

                var SignImage = document.getElementById("Image-sign");
                var signHeight = Number($('#Image-sign').height());
                var signWidth = Number($('#Image-sign').width());
                var xc = (offset.x - offset.offsetX) - $(Canvas).offset().left;
                var yc = (offset.y - offset.offsetY) - $(Canvas).offset().top;

                ctx.drawImage(SignImage, xc, yc, signWidth, signHeight);

                var length_canvas = $(".pdf-page-canvas").length;
                canvas = $(".pdf-page-canvas")[0];

                var doc = new jsPDF('p', 'mm');
                html2canvas(canvas, {
                    onrendered: function (canvas) {

                        for (var i = 0; i < $(".pdf-page-canvas").length; i++) {
                            canvas = $(".pdf-page-canvas")[i]
                            var name = canvas.toDataURL('image/png');
                            doc.addImage(name, 'PNG', 0, 0, 210, 297);
                            if (i != (length_canvas - 1)) doc.addPage();                          
                        } 

                        // var file = doc.output('datauri');
                        // var file = doc.output('blob');   
                        var fileEncode = btoa(doc.output());
                        var fd = new FormData();
                        fd.append('base64PDF', fileEncode);
                        fd.append("type", "Final");
                        fd.append("SignFile", sessionStorage.getItem("SignFile"));
                        fd.append("UserFile", sessionStorage.getItem("UserFile"));

                                          
                        $.ajax({
                            url: '/Sign/Upload',
                            headers: { "RequestVerificationToken": $('#form input:hidden[name="__RequestVerificationToken"]').val() },
                            data: fd,
                            dataType: 'text',
                            processData: false,
                            contentType: false,
                            type: 'POST',
                            success: function (response)
                            {
                                $('#loader-sign , #final_Confirm span').hide();
                                $('#Modal_share').modal({ backdrop: 'static', keyboard: false })
                                $('#pdf_download').tooltip();
                                $('#final_Confirm').remove();
                                //doc.save("file.pdf");
                            },
                            error: function (jqXHR) {
                                alter('Failure to send request');
                            }
                        });

                    },
                });
            
        });


        //$(document).on('keyup', '#form_share input', function (e) {

        //    if ($(this).next().find("span").prevObject[0].innerText != "") {
        //        $(this).css({ 'border-bottom': '2px solid #f44336', 'box-shadow': '0px 5px 5px #f4433645' })
        //    }
        //    else {
        //        $(this).css({ 'border': 'none', 'box-shadow': '0px 5px 5px rgba(96, 125, 139, 0.24)' })
        //    }

        //});
        //$(document).on('blur', '#form_share input', function (e) {

        //    if ($(this).next().find("span").prevObject[0].innerText != "") {
        //        $(this).css({ 'border-bottom': '2px solid #f44336', 'box-shadow': '0px 5px 5px #f4433645' })
        //    }
        //    else {
        //        $(this).css({ 'border': 'none', 'box-shadow': '0px 5px 5px rgba(96, 125, 139, 0.24)' })
        //    }
        //});

        function Delete(element) {
            $(element).parent('.movable_BoX').remove()
        }

        var Timer;
        $("#send_MobileCode").click(function () {
            var mobile = $('#MobilSender').val();
            if (
                mobile != 0 &&
                mobile != "" &&
                $('#MobilSender-error').text() == "" &&
                ($('#Holder_image span').attr('style') == undefined || $('#Holder_image span').attr('style') == "display: none;")
            ) {
                $("#Holder_image img").show();
                $.ajax({
                    url: "/Sign/SendConfirmCode",
                    headers: {"RequestVerificationToken": $('#form_share input:hidden[name="__RequestVerificationToken"]').val()},                   
                    data: { mobile: $('#MobilSender').val() },
                    type: "POST",
                    success: function (res) {
                        if (res == "NoAuth") {
                            $('#Modal_Error_sendMobileCode .alert.alert-danger').append("جهت احراز هویت از طریق <span>' کد تائید '</span> ابتدا وارد سایت شوید")
                            .append('<a href = "/Identity/Account/Login"> ورود به لامینگو</a>')                                             
                            $('#Modal_Error_sendMobileCode').modal({ backdrop: 'static', keyboard: false })
                        }
                        else if (res == "OK") {
                            $('#Modal_ConfirmCode').modal({ backdrop: 'static', keyboard: false })
                            $("#Modal_ConfirmCode").draggable({
                                handle: ".modal-content"
                            });                         
                            $('#Holder_image span').css({
                                'display': 'inline-block'
                            })
                            $('#send_MobileCode').css({
                                'cursor': 'default !important',
                                'box-shadow': 'none',
                                'opacity': '.5'
                            })
                            $(this).disabled = true;
                            Counter();
                        } else if (res == "NOK") {
                            $('#Modal_Error_sendMobileCode .alert.alert-danger').text(" خطایی در هنگام پردازش اطلاعات رخ داده است لطفا دقایقی دیگر مجددا اقدام نمائید.")
                            $('#Modal_Error_sendMobileCode').modal({ backdrop: 'static', keyboard: false })
                        }
                        else {
                            $('#Modal_Error_sendMobileCode .alert.alert-danger').text(" خطایی در هنگام پردازش اطلاعات رخ داده است.لطفا دقایقی دیگر مجددا اقدام نمائید.")
                            $('#Modal_Error_sendMobileCode').modal({ backdrop: 'static', keyboard: false })
                        } 

                        $("#Holder_image img").hide();
                    }
                });
            }
        })

        $("#Register_Confirm_Code").click(function () {
            var code = $('#confirmCode').val();
            if (code != 0 && code != "") {
                $("#Register_Confirm_Code").next().show();
                $.ajax({
                    url: "/Sign/VerifyPhoneNumber",
                    headers: { "RequestVerificationToken": $('#form_share input:hidden[name="__RequestVerificationToken"]').val() },   
                    data: { code: code , mobile : $("#MobilSender").val() },
                    type: "POST",
                    success: function (res) {
                        $("#Register_Confirm_Code").next().hide()
                        $('#Modal_ConfirmCode').modal('hide')
                        if (res == "OK") {
                            $("#mobile_Detail").hide();
                            $('#form_share .container .row i').remove();
                            $('#mobile_Detail').before('<i class="fa fa-check-circle-o" title="شماره موبایل وارد شده با موفقیت تائید شد."></i>');
                        } else if (res == "FaildVerifyPhoneNumber") {
                            clearInterval(Timer);
                            $('#form_share .container .row i').remove();
                            $('#mobile_Detail').before('<i class="fa fa-times-circle-o" title="شماره موبایل یا کد وارد شده اشتباه است مجددا اقدام نمائید."></i>');
                            $('#Holder_image>span').hide()
                            $('#Holder_image>span>span').text(10)
                            $('#send_MobileCode').css({
                                'cursor': 'pointer !important',
                                'box-shadow': '0px 5px 5px rgba(96, 125, 139, 0.24)',
                                'opacity': '1'
                            });
                        } else if (res == "NoAuth") {
                            $('#Modal_Error_sendMobileCode .alert.alert-danger').append("جهت احراز هویت از طریق <span>' کد تائید '</span> ابتدا وارد سایت شوید")
                                .append('<a href = "/Identity/Account/Login"> ورود به لامینگو</a>')
                            $('#Modal_Error_sendMobileCode').modal({ backdrop: 'static', keyboard: false })
                        }
                        else {
                            $('#Modal_Error_sendMobileCode .alert.alert-danger').text(" خطایی در هنگام پردازش اطلاعات رخ داده است.لطفا دقایقی دیگر مجددا اقدام نمائید.")
                            $('#Modal_Error_sendMobileCode').modal({ backdrop: 'static', keyboard: false })
                        } 
                    }
                });
            }
        })

        $('#pdf_download').click(function () {
            $('#pdf_download_loader , #Fade_Bg').show();
            $.ajax({
                method: 'POST',
                url: '/Sign/GetPDF',
                headers: { "RequestVerificationToken": $('#form_share input:hidden[name="__RequestVerificationToken"]').val() },
                xhrFields: { responseType: "blob" },              
                success: function (data) {                            
                    var blob = new Blob([data], { type: "application/pdf" })
                    var url = window.URL.createObjectURL(blob);
                    var a = document.createElement("a");
                    document.body.appendChild(a);
                    a.download = "Contract.pdf";
                    a.href = url;
                    a.style.display = 'none';
                    a.click();
                    $('#pdf_download_loader , #Fade_Bg').hide();
                }
            });           
        })

        
      



        function Counter() {
            Timer = setInterval(function () {
                var counter = Number($("#Holder_image")[0].children[1].lastChild.innerHTML);
                counter -= 1;
                if (counter < 10) counter = `0${counter}`
                $("#Holder_image span span").text(counter)
                if (counter == 0) {
                    clearInterval(Timer);
                    $('#Modal_ConfirmCode').modal('hide');
                    $("#Holder_image span").hide();
                    $("#Holder_image span span").text(60);
                    $('#send_MobileCode').css({
                        'cursor': 'pointer !important',
                        'box-shadow': '0px 5px 5px rgba(96, 125, 139, 0.24)',
                        'opacity': '1'
                    });
                }
            }, 1000)
        }

    </script>

}

@section Styles{
    <link href="~/css/Sign.css" rel="stylesheet" />
    <link href="~/css/jquery-ui.min.css" rel="stylesheet" />
}




<script>
     //ImageTracer.loadImage(
                //    'https://localhost:5001/Uploads/Sign/Image/' + data.file,
                //    function (canvas) {

                //        // Getting ImageData from canvas with the helper function getImgdata().
                //        var imgd = ImageTracer.getImgdata(canvas);

                //        // Synchronous tracing to SVG string
                //        var svgstr = ImageTracer.imagedataToSVG(imgd, { ltres: 1, qtres: 1, scale: 10, strokewidth: 5 });

                //        // Appending SVG
                //        ImageTracer.appendSVGString(svgstr, 'holder_Temperory');

                //        //var counter = 0
                //        //$('#holder_Temperory').children('svg').children('path').each(function () {
                //        //    $(this).css({ stroke: "#000", fill: "white" });
                //        //    if (counter == 2) {
                //        //        $(this)[0].outerHTML = $(this)[0].outerHTML.replace("M 0 0 L 8900 0 L 8900 5520 L 0 5520 L 0 0 Z", "")
                //        //    }
                //        //    counter++;
                //        //});

                //        var svg = $('#holder_Temperory svg')[0];
                //        var xml = (new XMLSerializer).serializeToString(svg);


                //        var Image = document.createElement('img');
                //        Image.id = 'Image-sign';
                //        Image.src = "data:image/svg+xml;charset=utf-8," + xml;
                //        $('.SignatureImageContainer').append(Image)
                //    }
                //);
</script>